VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "WinSock Spy"
   ClientHeight    =   4245
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4665
   Icon            =   "Spy.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4245
   ScaleWidth      =   4665
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame frmMain 
      Caption         =   "Transfer"
      Height          =   1905
      Index           =   1
      Left            =   0
      TabIndex        =   8
      Top             =   2205
      Width           =   4425
      Begin VB.CommandButton cmdKill 
         Caption         =   "Kill Connection"
         Height          =   330
         Left            =   2940
         TabIndex        =   10
         Top             =   1470
         Width           =   1380
      End
      Begin VB.CommandButton cmdRx 
         Caption         =   "Rx Packet"
         Height          =   330
         Left            =   1521
         TabIndex        =   11
         Top             =   1470
         Width           =   1380
      End
      Begin VB.CommandButton cmdTx 
         Caption         =   "Tx Packet"
         Height          =   330
         Left            =   105
         TabIndex        =   12
         Top             =   1470
         Width           =   1380
      End
      Begin VB.ListBox lstTrace 
         Height          =   1230
         Left            =   105
         TabIndex        =   9
         Top             =   210
         Width           =   4215
      End
   End
   Begin MSWinsockLib.Winsock sckTx 
      Left            =   3675
      Top             =   315
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Frame frmMain 
      Caption         =   "Connection"
      Height          =   1905
      Index           =   0
      Left            =   210
      TabIndex        =   0
      Top             =   105
      Width           =   2745
      Begin VB.CommandButton cmdListen 
         Caption         =   "Listen"
         Height          =   435
         Left            =   105
         TabIndex        =   7
         Top             =   1365
         Width           =   2535
      End
      Begin VB.TextBox txtRemotePort 
         Height          =   330
         Left            =   1170
         TabIndex        =   5
         Text            =   "1000"
         Top             =   1050
         Width           =   1485
      End
      Begin VB.TextBox txtRemoteIP 
         Height          =   330
         Left            =   1170
         TabIndex        =   3
         Text            =   "0.0.0.0"
         Top             =   735
         Width           =   1485
      End
      Begin VB.TextBox txtLocalPort 
         Height          =   330
         Left            =   1155
         TabIndex        =   1
         Text            =   "100"
         Top             =   210
         Width           =   1485
      End
      Begin VB.Label Label3 
         Alignment       =   1  'Right Justify
         AutoSize        =   -1  'True
         Caption         =   "Remote Port:"
         Height          =   195
         Left            =   150
         TabIndex        =   6
         Top             =   1050
         Width           =   930
      End
      Begin VB.Label Label2 
         Alignment       =   1  'Right Justify
         AutoSize        =   -1  'True
         Caption         =   "Remote Host:"
         Height          =   195
         Left            =   105
         TabIndex        =   4
         Top             =   735
         Width           =   975
      End
      Begin VB.Label Label1 
         Alignment       =   1  'Right Justify
         AutoSize        =   -1  'True
         Caption         =   "Local Port:"
         Height          =   195
         Left            =   300
         TabIndex        =   2
         Top             =   210
         Width           =   765
      End
   End
   Begin MSWinsockLib.Winsock sckRx 
      Left            =   3675
      Top             =   840
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'WinSock Spy
'Author: Phlip <phlipping@yahoo.com>
'Date: 2003/03/30
'
'Traces all data sent between two winsock programs, from
'the viewpoint of the client (ie Tx means client->server),
'also allows extra packets to be sent either way.
'
'Usually used for debugging WinSock applications, can be
'used on any socket application where the IP and port
'are entered into the client, or a socket application
'where you only enter the IP and you know what port it
'uses
'
'To Use:
'  Run the spy, type into the remote ip and port boxes what
'  you'd normally type into the client
'  Type any number you want into the local port box, 100 is
'  good.
'  Run the client program, tell it to connect to "localhost"
'  on whatever port you chose in the local port box.
'  If the port is hard-coded, set both the local and remote
'  ports to that number and connect to "localhost", this
'  doesn't work if your computer is running both the client
'  and the server.
'
'Note:
'  sckTx connects to the client, sckRx to the server, so:
'  sckTx_DataArrival is sending a packet
'  sckRx_DataArrival is receiving a packet
'  which makes sense, however this means that
'  sckTx.SendData is receiving a packet
'  sckRx.SendData is sending a packet
'  so watch out when reading parts of the code!

Option Explicit
'Used when connecting, local connection not accepted until
'remote connection accepted
Dim WaitForEvent As Boolean

'SwitchFrame
'Change which frame is displayed
'I often use this in large programs with many frames
Private Sub SwitchFrame(Index As Integer)
  With frmMain(Index)
    .ZOrder vbBringToFront
    .Left = 0
    .Top = 0
    'Width - ScaleWidth is form border width
    Width = Width - ScaleWidth + .Width
    Height = Height - ScaleHeight + .Height
  End With
End Sub

Private Sub cmdKill_Click()
  'Close connections and reset dialog
  sckTx.Close
  sckRx.Close
  SwitchFrame 0
  cmdListen.Caption = "Listen"
  txtLocalPort.Enabled = True
  txtRemoteIP.Enabled = True
  txtRemotePort.Enabled = True
End Sub

'This button could be "Listen" or "Stop", so have to check
Private Sub cmdListen_Click()
  If sckTx.State = sckClosed Then
    sckTx.LocalPort = txtLocalPort.Text
    sckTx.Listen
    cmdListen.Caption = "Stop"
    txtLocalPort.Enabled = False
    txtRemoteIP.Enabled = False
    txtRemotePort.Enabled = False
  Else
    sckTx.Close
    cmdListen.Caption = "Listen"
    txtLocalPort.Enabled = True
    txtRemoteIP.Enabled = True
    txtRemotePort.Enabled = True
  End If
End Sub

Private Sub cmdRx_Click()
  Dim A As String
  A = InputBox("Enter packet to receive:")
  If A = "" Then Exit Sub
  sckTx.SendData A
  lstTrace.AddItem "*Rx: " & A
End Sub

Private Sub cmdTx_Click()
  Dim A As String
  A = InputBox("Enter packet to send:")
  If A = "" Then Exit Sub
  sckRx.SendData A
  lstTrace.AddItem "*Tx: " & A
End Sub

Private Sub Form_Load()
  SwitchFrame 0
End Sub

Private Sub lstTrace_DblClick()
  lstTrace.Clear
End Sub

Private Sub sckRx_Close()
  cmdKill_Click
End Sub

Private Sub sckRx_Connect()
  WaitForEvent = False
End Sub

Private Sub sckRx_DataArrival(ByVal bytesTotal As Long)
  Dim Msg As String
  sckRx.GetData Msg
  sckTx.SendData Msg 'send message on to the client
  lstTrace.AddItem "Rx: " & Msg
End Sub

Private Sub sckRx_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
  WaitForEvent = False
End Sub

Private Sub sckTx_Close()
  cmdKill_Click
End Sub

Private Sub sckTx_ConnectionRequest(ByVal requestID As Long)
  sckTx.Close
  sckRx.Close
  sckRx.Connect txtRemoteIP.Text, txtRemotePort.Text
  WaitForEvent = True
  While WaitForEvent 'Wait until connected...
    DoEvents
  Wend
  If sckRx.State = sckConnected Then
    sckTx.Accept requestID '...then accept
    SwitchFrame 1
  End If
End Sub

Private Sub sckTx_DataArrival(ByVal bytesTotal As Long)
  Dim Msg As String
  sckTx.GetData Msg
  sckRx.SendData Msg 'send message on to server
  lstTrace.AddItem "Tx: " & Msg
End Sub

Private Sub sckTx_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
  WaitForEvent = False
End Sub

Private Sub txtLocalPort_KeyPress(KeyAscii As Integer)
  Select Case KeyAscii
    Case &H30 To &H39, 8 '0-9, bksp
      'do a lot of nothing
    Case Else
      KeyAscii = 0
      Beep
  End Select
End Sub

Private Sub txtRemotePort_KeyPress(KeyAscii As Integer)
  Select Case KeyAscii
    Case &H30 To &H39, 8 '0-9, bksp
      'do a lot of nothing
    Case Else
      KeyAscii = 0
      Beep
  End Select
End Sub
